#include "stdafx.h"
#include "DTimeUITest.h"
#include "DTimeUITestDlg.h"
#include "DTime+UI.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif //#ifdef _DEBUG


#pragma warning(suppress: 26455)
CDTimeUITestDlg::CDTimeUITestDlg(_In_opt_ CWnd* pParent) : CDialog{CDTimeUITestDlg::IDD, pParent},
                                                           m_Date{DTimePlus::CDate<DTimePlus::CGregorianCalendar>::CurrentLocalDate()},
                                                           m_TimeSpan{DTimePlus::CLTimeOfDay<>::CurrentLocalTime()},
                                                           m_hIcon{AfxGetApp()->LoadIcon(IDR_MAINFRAME)}
{
}

void CDTimeUITestDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
  DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER1, m_Date);
  DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER2, m_TimeSpan);
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CDTimeUITestDlg, CDialog) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
END_MESSAGE_MAP()

BOOL CDTimeUITestDlg::OnInitDialog()
{
  __super::OnInitDialog();
  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);
  return TRUE;
}

#pragma warning(suppress: 26434)
void CDTimeUITestDlg::OnPaint()
{
  if (IsIconic())
  {
    CPaintDC dc{this}; // device context for painting

#pragma warning(suppress: 26490)
    SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

    //Center icon in client rectangle
    const int cxIcon{GetSystemMetrics(SM_CXICON)};
    const int cyIcon{GetSystemMetrics(SM_CYICON)};
    CRect rect;
    GetClientRect(&rect);
    const int x{(rect.Width() - cxIcon + 1) / 2};
    const int y{(rect.Height() - cyIcon + 1) / 2};

    //Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
    __super::OnPaint();
}

#pragma warning(suppress: 26434 26440)
HCURSOR CDTimeUITestDlg::OnQueryDragIcon()
{
#pragma warning(suppress: 26473)
  return static_cast<HCURSOR>(m_hIcon);
}
