#pragma once

#include "DTime+.h"


class CDTimeUITestDlg : public CDialog
{
public:
//Constructors / Destructors
  CDTimeUITestDlg(_In_opt_ CWnd* pParent = nullptr);
  CDTimeUITestDlg(const CDTimeUITestDlg&) = delete;
  CDTimeUITestDlg(CDTimeUITestDlg&&) = delete;
  ~CDTimeUITestDlg() = default; //NOLINT(modernize-use-override)

//Methods
  CDTimeUITestDlg& operator=(const CDTimeUITestDlg&) = delete;
  CDTimeUITestDlg& operator=(CDTimeUITestDlg&&) = delete;

//Member variables
  enum { IDD = IDD_DTIMEUITEST_DIALOG };
  DTimePlus::CDate<DTimePlus::CGregorianCalendar> m_Date;
  DTimePlus::CLTimeOfDay<>m_TimeSpan;

protected:
//Member variables
  HICON m_hIcon;

//Message handlers
  void DoDataExchange(CDataExchange* pDX) override;
  BOOL OnInitDialog() override;

  afx_msg void OnPaint();
  afx_msg HCURSOR OnQueryDragIcon();

  DECLARE_MESSAGE_MAP()
};
